



#include <hype.h>


int main(){

	hype_add_algorithm_to_operation("SORT","BubbleSort",CPU,"LEAST_SQUARES","PERIODIC");
	hype_add_algorithm_to_operation("SORT","MergeSort",CPU,"LEAST_SQUARES","EVENTBASED");
	hype_add_algorithm_to_operation("SORT","QuickSort",CPU,"SPLINES","HYBRID");
	

	if(!hype_set_optimization_criterion("SORT","RESPONSE TIME")) printf("Error\n");
	if(!hype_set_optimization_criterion("MERGE","Throughput")) printf("Error\n");

	if(!hype_set_statistical_method("Quicksort","LEAST_SQUARES")) printf("Error\n");
	if(!hype_set_statistical_method("Bubblesort","SPLINES")) printf("Error\n");

	if(!hype_set_recomputation_heuristic("Quicksort","EVENTBASED")) printf("Error\n");
	if(!hype_set_recomputation_heuristic("Bubblesort","PERIODIC")) printf("Error\n");

	double values[2];
	values[0]=1;
	values[1]=3;

	C_SchedulingDecision *decision = hype_get_scheduling_decision("SORT", values, sizeof(values));
	C_AlgorithmMeasurement c_algmeasure;

	hype_before_algorithm_execution(&c_algmeasure,decision,values,sizeof(values)); //starts timer

	hype_after_algorithm_execution(&c_algmeasure); //stops timer
	//after this,  c_algmeasure has to be initialized again!

	free(decision);

	return 0;
}

