
#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <memory>

//loki library
//#include <loki/Singleton.h>
#include <loki/Factory.h>

//STEMOD includes
#include <core/recomputation_heuristic.hpp>
#include <core/time_measurement.hpp>

namespace hype{
	namespace core{

	class RelativeErrorBasedRecomputation : public RecomputationHeuristic {
		
		public:
		RelativeErrorBasedRecomputation();
		explicit RelativeErrorBasedRecomputation(const double& error_threshold);
		/*! returns true, if approximation function has to be recomputed and false otherwise*/
		virtual bool internal_recompute(Algorithm& algortihm);

		static RecomputationHeuristic* create(){
			return new RelativeErrorBasedRecomputation();
		}

		private:
		unsigned int counter_;
		double error_threshold_;
	};

	}; //end namespace core
}; //end namespace stemod


