
#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <memory>

//loki library
//#include <loki/Singleton.h>
#include <loki/Factory.h>

//STEMOD includes
#include <core/recomputation_heuristic.hpp>
#include <core/time_measurement.hpp>

namespace hype{
	namespace core{

	class Oneshotcomputation : public RecomputationHeuristic {
		
		public:
		Oneshotcomputation();
		/*! returns true, if approximation function has to be recomputed and false otherwise*/
		virtual bool internal_recompute(Algorithm& algortihm);

		static Oneshotcomputation* create(){
			return new Oneshotcomputation();
		}

		private:
		bool once_;
		unsigned int counter_;
	};

	}; //end namespace core
}; //end namespace stemod
